#define BLYNK_PRINT Serial    // Comment this out to disable prints and save space
#include <SPI.h>
#include <ESP8266WiFi.h>
#include <BlynkSimpleEsp8266.h>
#include <SimpleTimer.h>
#include <DHT.h>
#include <Adafruit_Sensor.h>
#include<NewPing.h>
// You should get Auth Token in the Blynk App at the time of //project creation to registered mail.

char auth[] = "";

// Your WiFi credentials.
// Set password to "" for open networks.
char ssid[] = "";
char pass[] = "";

#define DHTPIN D2          // What digital pin we're connected to
#define TRIGGER 16
#define ECHO    5
// NodeMCU Pin D0 > TRIGGER | Pin D1 > ECHO
#define DHTTYPE DHT11     // DHT 11

DHT dht(DHTPIN, DHTTYPE);
SimpleTimer timer;

int low=1024;
int high=390;
int m=19;
int ma=0;
void sendSensor()
{
  float h = dht.readHumidity();
  float t = dht.readTemperature();
  int r=analogRead(A0);
//Serial.println(r);
int per=map(r,low,high, 0,100);
//Serial.println(per);
long duration, distance;
  digitalWrite(TRIGGER, LOW);  
  delayMicroseconds(2); 
  
  digitalWrite(TRIGGER, HIGH);
  delayMicroseconds(10); 
  
  digitalWrite(TRIGGER, LOW);
  duration = pulseIn(ECHO, HIGH);
  distance = (duration/2) / 29.1;
  Serial.print(distance);
  Serial.println("Centimeter:");
 
 int z=20;//taken height of tank is 20cm
 int y=z- distance;
 int l=y*5;
  if (isnan(h) || isnan(t)) {
    Serial.println("Failed to read from DHT sensor!");
    return;
  }
  // You can send any value at any time.
  // Please don't send more that 10 values per second.
  Blynk.virtualWrite(V5, h);
  Blynk.virtualWrite(V6, t);
  Blynk.virtualWrite(V7, per);//soil dry percentage
   Blynk.virtualWrite(V8, l);// water level percentage
  
}

void setup()
{
  Serial.begin(9600); // See the connection status in Serial Monitor
  
  Blynk.begin(auth, ssid, pass);
pinMode(TRIGGER, OUTPUT);
  pinMode(ECHO, INPUT);
  dht.begin();

  // Setup a function to be called every second
  timer.setInterval(1000L, sendSensor);
}

void loop()
{
 
  Blynk.run(); // Initiates Blynk
  timer.run(); // Initiates SimpleTimer
  
}
